// FileTrim.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "FileTrim.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

//CWinApp theApp;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		return(1);

	}


	if(argc<2)
	{
		cout<<"Usage: filetrim.exe <infile> <outfile>"<<endl;

		return(2);
	}

	cout<<"FileTrim utility - replaces multiple consequetive empty strings"<<endl;
	cout<<"with single empty line. A line containing only spaces, tabs,"<<endl;
	cout<<"new line characters is considered to be empty."<<endl;
	cout<<"Copyright (c) 2001 by Akbar Avliyaev, akbaraka@yahoo.com"<<endl;
	cout<<"This program is freeware - use it for free."<<endl;
	cout<<"No warranty whatsoever   - use at your own risk."<<endl;
	
	
	
	CStdioFile inFile, outFile;

	if(!inFile.Open(argv[1],CFile::modeRead))
	{
		cerr<<"Error opening input file "<<argv[1]<<" - exiting."<<endl;
		return(3);
	}

	if(!outFile.Open(argv[2],CFile::modeWrite|CFile::modeCreate))
	{
		cerr<<"Error opening output file "<<argv[2]<<" - exiting."<<endl;
		return(4);
	}

	CString str; //the string read 
	CString strTmp; 
	BOOL prevEmpty=FALSE; //was the previous line empty?
	
	TRY{
		while(inFile.ReadString(str)){
				
			strTmp=str;
			strTmp.TrimLeft();
	
			if(strTmp.GetLength())
			{
				outFile.WriteString(str+'\n');
				prevEmpty=FALSE;
			}
			else
			{
				if(!prevEmpty)
				{
					outFile.WriteString("\n");
					prevEmpty=TRUE;
				}
			}
		}
	}
	CATCH(CFileException,ex)
	{
		switch(ex->m_cause)
		{
		case CFileException::directoryFull:
			cout<<"Disk is full - exiting"<<endl;
			return(5);
			break;
		case CFileException::generic:
			cout<<"Unknown error occured - exiting"<<endl;
			return(6);
			break;
		}

	}
	END_CATCH

	cout<<"..."<<endl<<"Finished "<<endl;

	return(0);
}


